	PAGE	,132

; --	absread -- absolute track and sector read
;		Version 1.1		December 30, 1985
;		Glenn F. Roberts
;		calling convention:
;			absread(drive, nsect, sector, &buffer);
;		where:
;			drive = drive no. (A=0, B=1, ...)
;			nsect = number of sectors to read
;			sector = beginning logical sector number
;			buffer = array to hold data
;		returns:
;				0			Normal return, no error
;				1			Write protect violation
;				2			Unknown unit
;				3			Drive not ready
;				4			Unknown command
;				5			CRC error
;				6			Bad drive request structure length
;				7			Seek error
;				8			Unknown media
;				9			Sector not found
;				10			Printer out of paper
;				11			Write fault
;				12			Read fault
;				13			General disk failure

_text		SEGMENT	BYTE PUBLIC 'CODE'
			ASSUME	CS:_text
			
			PUBLIC	_absread
			
_absread PROC	NEAR
			push	bp						;Set up stack addressing
			mov	bp,sp
			push	di
			push	si
			
			mov	ax,[bp+4]			;AX = drive number
			mov	cx,[bp+6]			;CX = number of sectors
			mov	dx,[bp+8]			;DX = starting record
			mov	bx,[bp+10]			;DS:BX = buffer address
			
			int	025h					;request absolute read
			inc	sp
			inc	sp						;fix the stack
			jc		error					;if error, then return code
			xor	ax,ax					;else show normal return = 0
			jmp	short done			;and then exit
			
error:	mov	ah,0					;error - zero high byte
			inc	al						;and increment error no.
			
done:		pop	si						;restore registers
			pop	di
			pop	bp
			ret							;and return
_absread ENDP

_text		ENDS
			END
			
