#include <bios.h>
#include <alloc.h>
#include <dos.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <conio.h>
#include <stdlib.h>
#include "graphics.h"

#define VidIntr(x) int86 (0x10,&x,&x)

/************************************************************************/
/*									*/
/*	Graphics.c a graphics library for use with turbo-c		*/
/*	This provides the user with turbo pascal style windowing	*/
/*	it only provides one kind of text output.			*/
/*	To output text use "Puts" in text modes and "GPuts" in		*/
/*	graphics mode. To output text in a printf format use		*/
/*	the "sprintf" command to a string then use Puts to		*/
/*	print it to the screen.						*/
/*									*/
/*	Note : DO NOT use any variables preceeded by a double		*/
/*	underline these are hidden from general use and should 		*/
/*	never be accessed directly. These are for internal use		*/
/*	by the library and not for general consumption.			*/
/*									*/
/*	Version 1.2 Release B 						*/
/*	(C) copyright 1987 Borland Intl.				*/
/*									*/
/*	Written by someone who is not going give any support 		*/
/*	on this one !!! It probably ain't bug free if you find		*/
/*	any please send mail to peteri on Compulink Information		*/
/*	eXchange. (CIX)                                                 */
/*									*/
/*	For support do NOT phone Borland send a message over		*/
/*	CIX to peteri and I will try to fix the problem			*/
/*									*/
/************************************************************************/

/*									*/
/*	V1.1 Updates 	Added Printf & GPrintf				*/
/*		 	Added OpenWindow & CloseWindow			*/
/*									*/

/*									*/
/*	V1.2 Updates	Added FastPlotting & Line Draw			*/
/*									*/

/*									*/
/*	Note : No parameter checking is done (I'm to lazy)		*/
/*	so be careful out there						*/
/*									*/

int __PageNumber,__CurX,__CurY,__Attr,__ScreenWidth,__Gcol;
int __GRBKG=0;
int __Widths[7]={40,40,80,80,40,40,80};
int __Win[4]={0,0,79,24};
int __Base;
char __String[2000];
window * __CurWindow=NULL;
int *__Buffer;
int __Offs [200];

void SetMode (scrmode Mode)

{ union REGS Regs;
  int y;
  Regs.h.ah=0x00;
  Regs.h.al=Mode;
  VidIntr (Regs);
  __PageNumber=0;
  __ScreenWidth=__Widths[Mode];
  Window (1,1,__ScreenWidth,25);
  if ((biosequip()&0x18)==0x18)	__Base=MONOBASE;
			   else __Base=CGABASE;
  for (y=0;y<200;y++)
    __Offs[y]= ((y*40) + (y&1 ? 0x1fd8:0));
}

void GotoXY (int x,int y)

{ union REGS Regs;
  Regs.h.ah=0x02;
  Regs.h.bh=__PageNumber;
  Regs.h.dh=y-1+__Win[1];
  Regs.h.dl=x-1+__Win[0];
  __CurX=x;
  __CurY=y;
  VidIntr (Regs);
}

void SetTextColor (colors ForeGrnd, colors BackGrnd)

{ __Attr=ForeGrnd+BackGrnd*16;
}

void SelectScreenPage (int NewPage)

{ union REGS Regs;
  __PageNumber=NewPage;
  Regs.h.ah=0x05;
  Regs.h.al=NewPage;
  VidIntr (Regs);
  if ((biosequip()&0x18)==0x18)	__Base=MONOBASE;
			   else __Base=CGABASE;
  __Base+=(NewPage*((__ScreenWidth==80) ? 2048 : 4096));
}

void ScrollScreen (direction Dir, int NoOfLines,
              int TopX, int TopY,
              int BotX, int BotY)

{ union REGS Regs;
  Regs.h.ah=0x06+Dir;
  Regs.h.al=NoOfLines;
  Regs.h.bh=__Attr;
  Regs.h.ch=TopY;
  Regs.h.cl=TopX;
  Regs.h.dh=BotY;
  Regs.h.dl=BotX;
  VidIntr (Regs);
}

void SetTextBorder (colors Col)

{ union REGS Regs;
  Regs.h.ah=0x0b;
  Regs.h.bh=0x00;
  Regs.h.bl=Col;
  VidIntr (Regs);
}

void SetGraphicsBackground (colors Col)

{ SetTextBorder (Col);
  __GRBKG=Col;
}

void SetGraphicsPallette (int Pal)

{ union REGS Regs;
  Regs.h.ah=0x0b;
  Regs.h.bh=0x01;
  Regs.h.bl=Pal&0x01;
  VidIntr (Regs);
  SetGraphicsBackground ((__GRBKG&0x0f)+((Pal<<3)&0x10));
}

void PutChar (char CH)

{ union REGS Regs;
  Regs.h.ah=0x09;
  Regs.h.al=CH;
  Regs.x.cx=0x01;
  Regs.h.bl=__Attr;
  Regs.h.bh=__PageNumber;
  if (CH>=32)
  { VidIntr (Regs);
    __CurX++;
  }
  else
    switch (CH)
    { case '\n' : __CurX=1;__CurY++;break;
      case '\t' : __CurX=(__CurX+8)& 0xfff8 ;break;
      case '\b' : __CurX--;break;
      default : VidIntr (Regs);
    };
  if (__CurX<1) {__CurX=1; __CurY--;};
  if (__CurX>__ScreenWidth) {__CurX=1;__CurY++;};
  if (__CurY<1) __CurY=1;
  if (__CurY>(__Win[3]-__Win[1])+1)
    {__CurY=(__Win[3]-__Win[1])+1;
     if (__Win[3]==__Win[1])
     ScrollScreen (UP,0,__Win[0],__Win[1],__Win[2],__Win[3]);
     else
     ScrollScreen (UP,1,__Win[0],__Win[1],__Win[2],__Win[3]);
    };
  GotoXY (__CurX,__CurY);
}

void Puts (char far *String)

{ while (*String) PutChar (*String++);
}

void SetGTextColor (Gcolors col)

{__Gcol=col&3;
}

void GPutChar (char CH)

{ union REGS Regs;
  Regs.h.ah=0x09;
  Regs.h.al=CH;
  Regs.x.cx=0x01;
  Regs.h.bl=__Gcol;
  Regs.h.bh=__PageNumber;
  if (CH>=32)
  { VidIntr (Regs);
    __CurX++;
  }
  else
    switch (CH)
    { case '\n' : __CurX=1;__CurY++;break;
      case '\t' : __CurX=(__CurX+8)& 0xfff8 ;break;
      case '\b' : __CurX--;break;
      default : VidIntr (Regs);
    };
  if (__CurX<1) {__CurX=1; __CurY--;};
  if (__CurX>__ScreenWidth) {__CurX=1;__CurY++;};
  if (__CurY<1) __CurY=1;
  if (__CurY>(__Win[3]-__Win[1])+1)
    {__CurY=(__Win[3]-__Win[1])+1;
     if (__Win[3]==__Win[1])
     ScrollScreen (UP,0,__Win[0],__Win[1],__Win[2],__Win[3]);
     else
     ScrollScreen (UP,1,__Win[0],__Win[1],__Win[2],__Win[3]);
    };
  GotoXY (__CurX,__CurY);
}

void GPuts (char far *String)

{ while (*String) GPutChar (*String++);
}

void Window (int TopX,int TopY,int BotX,int BotY)

{ __Win[0]=TopX-1;
  __Win[1]=TopY-1;
  __Win[2]=BotX-1;
  __Win[3]=BotY-1;
  __ScreenWidth=BotX-TopX+1;
  GotoXY(1,1);
}

void ClearWindow (void)

{ ScrollScreen (UP,0,__Win[0],__Win[1],__Win[2],__Win[3]);
  GotoXY(1,1);
}

int whereisx(void)

{ return (__CurX);
}

int whereisy(void)

{ return (__CurY);
}

int __Mask []={0xC0,0x30,0x0C,0x03} ; /* Bit masks !! */
int __NotMask [] = {0x3F,0xCF,0xF3,0xFC};
int __Colors []={0x00,0x55,0xAA,0xFF} ; /*Colors preshifted ? */


void Mplot (int x,int y,Gcolors col)

{ char far * Dst;
  Dst=MK_FP(__Base,__Offs[y]+(x>>2));
  x&=3;
  *Dst=(*Dst & __NotMask[x]) | (__Mask[x] & __Colors[col&3]);
}


void Printf(char *format,...)
{
   va_list argptr ;                 /* gain access to the arg string */
   va_start(argptr,format) ;
   vsprintf(__String,format,argptr); /* parse the format string */
   va_end(argptr) ;                 /* end access to the arg string */
   Puts(__String) ;       /* do our stuff */
}

void GPrintf(char *format,...)
{
   va_list argptr ;                 /* gain access to the arg string */
   va_start(argptr,format) ;
   vsprintf(__String,format,argptr) ; /* parse the format string */
   va_end(argptr) ;                 /* end access to the arg string */
   GPuts(__String) ;       /* do our stuff */
}

/*								*/
/*	This restores a text area to the screen.		*/
/*	this should really be written is assembler.		*/
/*								*/

void PutScreen (int *Buffer,int TopX,int TopY,int BotX,int BotY)

{ int DstOff;			/* where we are going to	*/
  int far *Src;			/* where we are coming from	*/
  unsigned SrcSeg,SrcOff;
  int w;			/* the width of the area	*/
  int h;			/* the height of the area	*/

  w=(BotX-TopX+1)*2;		/* calculate the width in bytes	*/
  h=BotY-TopY+1;		/* calculate the height		*/
  Src=(int far *) Buffer;	/* force a far address of Buffer*/
  SrcSeg=FP_SEG(Src);
  SrcOff=FP_OFF(Src);
  /*								*/
  /* it is possible but unlikely that SrcOff will overflow	*/
  /* during the move. Here we cater for this event		*/
  /*								*/
  SrcSeg=SrcSeg+(SrcOff>>4);
  SrcOff=SrcOff&0x0f;
  DstOff=(TopY-1)*160+(TopX-1)*2;
  while (h--)
  { movedata (SrcSeg,SrcOff,__Base,DstOff,w);
    SrcOff=SrcOff+w; DstOff=DstOff+160;
  }
}

/*								*/
/*	This saves a screen area and allocates a buffer		*/
/*								*/

int *GetScreen (int TopX,int TopY,int BotX,int BotY)

{ int SrcOff;			/* where we coming from		*/
  int far *Dst;			/* where we are going to	*/
  unsigned DstSeg,DstOff;
  int *Buffer;			/* where our patch is		*/
  int w;			/* the width of the area	*/
  int h;			/* the height of the area	*/

  w=(BotX-TopX+1)*2;		/* calculate the width in bytes	*/
  h=BotY-TopY+1;		/* calculate the height		*/
  Buffer=malloc (w*h);		/* get some memory		*/
  Dst=(int far *) Buffer;	/* force a far address of Buffer*/
  DstSeg=FP_SEG(Dst);
  DstOff=FP_OFF(Dst);
  /*								*/
  /* it is possible but unlikely that DstOff will overflow	*/
  /* during the move. Here we cater for this event		*/
  /*								*/
  DstSeg=DstSeg+(DstOff>>4);
  DstOff=DstOff&0x0f;
  SrcOff=(TopY-1)*160+(TopX-1)*2;
  while (h--)
  { movedata (__Base,SrcOff,DstSeg,DstOff,w);
    SrcOff=SrcOff+160; DstOff=DstOff+w;
  }
  return (Buffer);		/* send back our value		*/
}

void OpenWindow (int TopX,int TopY, int BotX,int BotY, char * Title)

{ int x;
  window *ThisWindow;

  ThisWindow = malloc (sizeof (window));
  ThisWindow->Previous=__CurWindow;
  ThisWindow->TopX=TopX;
  ThisWindow->TopY=TopY;
  ThisWindow->BotX=BotX;
  ThisWindow->BotY=BotY;
  ThisWindow->OTX=__Win[0]+1;
  ThisWindow->OTY=__Win[1]+1;
  ThisWindow->OBX=__Win[2]+1;
  ThisWindow->OBY=__Win[3]+1;
  ThisWindow->CX=whereisx();
  ThisWindow->CY=whereisy();
  ThisWindow->Buffer = GetScreen (TopX,TopY,BotX,BotY);
  __CurWindow=ThisWindow;
  Window (TopX,TopY,BotX+1,BotY);
  GotoXY (BotX-TopX+1,BotY-TopY+1);
  PutChar(188);
  for (x=2;x<=(BotX-TopX);x++)
  { GotoXY (x,1); PutChar (205);
    GotoXY (x,BotY-TopY+1); PutChar (205);
  };
  for (x=2;x<=(BotY-TopY);x++)
  { GotoXY (1,x); PutChar (186);
    GotoXY (BotX-TopX+1,x); PutChar (186);
  };
  GotoXY (1,1);
  PutChar (201);
  GotoXY (1,BotY-TopY+1);
  PutChar (200);
  GotoXY (BotX-TopX+1,1);       	
  PutChar (187);
  x=(BotX-TopX-strlen (Title))/2+1;
  GotoXY (x,1);
  Puts(Title);
  Window (TopX+1,TopY+1,BotX-1,BotY-1);
}

int CloseWindow (void)

{ window *temp;
  if (__CurWindow==NULL) return (-1);
  PutScreen(__CurWindow->Buffer,__CurWindow->TopX,__CurWindow->TopY,
            __CurWindow->BotX,__CurWindow->BotY);
  free (__CurWindow->Buffer);
  temp=__CurWindow;
  __CurWindow=temp->Previous;
  Window (temp->OTX,temp->OTY,temp->OBX,temp->OBY);
  GotoXY (temp->CX,temp->CY);
  free (temp);
  return (0);
}


void GDrawLine(int X1, int Y1, int X2, int Y2, Gcolors Col )

{
int   X, Y, DeltaX, DeltaY, XStep, YStep, Direction;
int Xoffs,xand3,Color,Yoffs;
char far * Dst;

  X = X1; Y = Y1;
  Color=__Colors[Col&3];
  XStep = (X1 > X2) ? -1 : 1;
  YStep = (Y1 > Y2) ? -1 : 1;
  DeltaX = abs(X2 - X1);
  DeltaY = abs(Y2 - Y1);
  Direction = (DeltaX ? 0: -1);
  Yoffs=__Offs[Y];
  Xoffs=(X>>2);
  xand3=X&3;
  while ((X != X2) || (Y != Y2))
  { Dst=MK_FP(__Base, (Yoffs+Xoffs));
    *Dst=(*Dst & __NotMask[xand3]) | (__Mask[xand3] & Color);
      if (Direction < 0)
      {
        Y += YStep;
        Direction += DeltaX;
        Yoffs=__Offs[Y];
      }
    else
      {
        X += XStep;
        xand3=X&3;
        Xoffs=(X>>2);
        Direction -= DeltaY;
      };
   if (kbhit()) exit (-1);
   }
}

__HMask []={0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
__NotHMask []={0x7f,0xbf,0xdf,0xef,0xf7,0xfb,0xfd,0xfe};

void Hplot (int x,int y)

{ char far * Dst;
  Dst=MK_FP(__Base,__Offs[y]+(x>>3));
  *Dst |= __HMask[x&7];
}

void Hunplot (int x,int y)

{ char far * Dst;
  Dst=MK_FP(__Base,__Offs[y]+(x>>3));
  *Dst &= __NotHMask[x&7];
}


void HDrawLineFrGr (int X1, int Y1, int X2, int Y2 )

{
int   X, Y, DeltaX, DeltaY, XStep, YStep, Direction;
int Xoffs,Yoffs;
char far * Dst;

  X = X1; Y = Y1;
  XStep = (X1 > X2) ? -1 : 1;
  YStep = (Y1 > Y2) ? -1 : 1;
  DeltaX = abs(X2 - X1);
  DeltaY = abs(Y2 - Y1);
  Direction = (DeltaX ? 0: -1);
  Yoffs=__Offs[Y];
  Xoffs=(X>>3);
  while ((X != X2) || (Y != Y2))
  { Dst=MK_FP(__Base, (Xoffs+Yoffs));
    *Dst |= __HMask[X&7];
      if (Direction < 0)
      {
        Y += YStep;
        Direction += DeltaX;
        Yoffs=__Offs[Y];
      }
    else
      {
        X += XStep;
        Xoffs=(X>>3);
        Direction -= DeltaY;
      };
   }
}

void HDrawLineBkGr (int X1, int Y1, int X2, int Y2 )

{
int   X, Y, DeltaX, DeltaY, XStep, YStep, Direction;
int Xoffs,Yoffs;
char far * Dst;

  X = X1; Y = Y1;
  XStep = (X1 > X2) ? -1 : 1;
  YStep = (Y1 > Y2) ? -1 : 1;
  DeltaX = abs(X2 - X1);
  DeltaY = abs(Y2 - Y1);
  Direction = (DeltaX ? 0: -1);
  Yoffs=__Offs[Y];
  Xoffs=(X>>3);
  while ((X != X2) || (Y != Y2))
  { Dst=MK_FP(__Base,(Xoffs+Yoffs));
    *Dst&= __NotHMask[X&7];
      if (Direction < 0)
      {
        Y += YStep;
        Direction += DeltaX;
        Yoffs=__Offs[Y];
      }
    else
      {
        X += XStep;
        Xoffs=(X>>3);
        Direction -= DeltaY;
      };
   }
}
